/* MSM  Maximum Likelihood Estimation   M Boldin  (4/96) */
/*   estimates models in Table 1 */
/*   first  run  mgt1a.prg to set model data  */

disable;
output file=mg1bo.out off;


Mtitle="MSM-- GNP growth"; _otitle=Mtitle;
y=xdat[.,2];  /* Data Hamilton used */
X=X0[.,1];

yr0=1947;
fyr=1952; __ftt=(fyr-yr0)*4 + 2;
lyr=1984; __ltt=(lyr-yr0+1)*4;

call msminit;
ns=2;  __nxsees=1;   arn=4;   __arnns=1;

/* Starting values  */
let sval0= -0.25 1.25  0.75   0 0 0 0   .75  .10;
        /*   b1   b2   see    rhos1-4   q11   q21 */
call msmr(sval0);

y=xdat[.,3];  /* revised GNP data  */
call msmr(bh);  /* starting values = results from last run (bh) */

/* Alternative starting values  */
let sval0= -1.50  0.75   0.75   0 0 0 0   .25 .05;
 call msmr(sval0);

/* Extend sample period to 1994 */
lyr=1994; __ltt=(lyr-yr0+1)*4;
call msmr(bh);  /* starting values = results from last run (bh) */

/* Alternative starting values  */
lyr=1984; __ltt=(lyr-yr0+1)*4;
let sval0= -2.0   1.0    0.80   0 0 0 0   .05  .05;
call msmr(sval0);
lyr=1994; __ltt=(lyr-yr0+1)*4;
call msmr(bh);

/* final values, using q11=0 restriction */
__rq=3.1;    __xqk=2;  __nxq=1;
sval0=vec(bs')|vec(sees[1])|vec(rhos[.,1]')|vec(q[2,2]');
call msmr(sval0);


@
/* Final estimates */
let sval0=  -2.0893   0.8103   0.8332
             0.2738   0.1989  -0.0997  -0.1520
             0.00001  0.0259;

lyr=1994; __ltt=(lyr-yr0+1)*4;
call msmr(sval0);

let sval0=  -2.1105   0.7694   0.7589
             0.2887   0.2142  -0.1007  -0.1302
             0.00001  0.0199;
@
