/* MSM  Maximum Likelihood Estimation   M Boldin  (4/96) */
/*  after estimating MSM1 & MSM4,            */
/*  full sample probabilitites are computed  */

disable;
output file=mgt1co.out off;
output file=mgt1co.ou3 off;


Mtitle="MSM-- GNP growth"; _otitle=Mtitle;
y=xdat[.,3];  /* revised GNP data  */
X=X0[.,1];

yr0=1947;
fyr=1952; __ftt=(fyr-yr0)*4 + 2;
lyr=1984; __ltt=(lyr-yr0+1)*4;

call msminit;
__runno=0;  __sval=0;  __regtbl=0;
ns=2;  __nxsees=1;   arn=4;   __arnns=1;
__smtabl=1;

/* Starting values  */
let sval0= -0.25 1.25  0.75   0 0 0 0   .75  .10;
        /*   b1   b2   see    rhos1-4   q11   q21 */
call msmr(sval0);
fspm0=fspy;

output on;
/* Extend sample period to 1994 */
lyr=1994; __ltt=(lyr-yr0+1)*4;
{ Fsy,mlsy,fspy } = smtabl(ddates,__ftt,__ltt,0);
fspm1=fspy;

call msmr(bh);  /* starting values = results from last run (bh) */
fspm4=fspy;

output on;
print; print;
mv=miss(0,0);
nr0=rows(fspm1)-rows(fspm0);
fspm0=fspm0|reshape(mv,nr0,2);
format /rd 9,4;
"             GNP       Recession probabilities";
"Date        growth     MSM0      MSM1      MSM4"
ddates[__ftt:__ltt]~y[__ftt:__ltt]~fspm0[.,1]~fspm1[.,1]~fspm4[.,1];
print; print;
output off;

end;

