/* MSM  Maximum Likelihood Estimation   M Boldin  (4/96) */
/*   Important: MGNP1 should be run first to read and intitialize data  */

/*   Table 2,  relaxing cross equation restrictions    */
/*   This is set up for one example,                   */
/*     a sequence of models are based on MSM4          */
/*     the full set of model tests can be relicated    */
/*     replacing staeting values in "let sval0= ..." statement    */


disable;
output file=mgt2ao.out off;

Mtitle="MSM-- GNP growth"; _otitle=Mtitle;
y=xdat[.,3];  /* Data Hamilton used */
X=X0[.,1];

yr0=1947;
fyr=1952; __ftt=(fyr-yr0)*4 + 2;
lyr=1994; __ltt=(lyr-yr0+1)*4;


call msminit;
__runno=0;  __sval=0;  __regtbl=0;

ns=2;  __nxsees=1;   arn=4;  __rhosx=1.1;
/* Starting values  */
let sval0=
     -1.5483   0.8057
          0.7290
          0.3393
          0.1385
         -0.1552
         -0.0523
      0.2374
      0.0316;
call msmr(sval0);

/* Relax cross equation restrictions */
sval0a=vec(bs')|vec(sees[1 1])|vec(rhos[.,1]')|vec(q[.,1:ns-1]');
sval0b=vec(bs')|vec(sees[1])|vec(rhos')|vec(q[.,1:ns-1]');
sval0c=vec(bs')|vec(sees[1 1])|vec(rhos')|vec(q[.,1:ns-1]');

ns=2;  __nxsees=0;   arn=4;   __rhosx=1.1;
call msmr(sval0a);  /* relax sees (sigma) restricition */

sval0d=vec(bs')|vec(sees[1 1])|vec(rhos')|vec(q[.,1:ns-1]');
ns=2;  __nxsees=1;   arn=4;   __rhosx=0;
call msmr(sval0b);  /* relax rhos (AR) restricition */

sval0e=vec(bs')|vec(sees[1 1])|vec(rhos')|vec(q[.,1:ns-1]');
ns=2;  __nxsees=0;   arn=4;   __rhosx=0;
call msmr(sval0c);   /* relax both sees and rhos restricitions */
call msmr(sval0d);
call msmr(sval0e);

@
let sval0= -1.5  0.80  0.75   0 0 0 0   .20  .05;
        /*   b1   b2   see    rhos1-4   q11   q21 */
@
