/* MSM  Maximum Likelihood Estimation   M Boldin  (4/96) */
/*   Hamilton's Model  */
/*  for SNDE articel table 3 */

disable;
output file=mgt3o.out off;

Mtitle="MSM-- GNP growth"; _otitle=Mtitle;
y=xdat[.,3];  /* Data Hamilton used */
X=X0[.,1];

yr0=1947;
fyr=1952; __ftt=(fyr-yr0)*4 + 2;
lyr=1994; __ltt=(lyr-yr0+1)*4;

call msminit;
__runno=0;  __sval=0;  __regtbl=0;

ns=2;  __nxsees=0;   arn=0;   __rhosx=0;   __rq=1;
let sval0= -0.25 1.25  0.75  0.75  .75  .10;
        /*   b1   b2   see         q11  q21  */
let sval0=
    -0.2493   0.9992
     0.9441   0.6994
     0.7486
     0.0753;
call msmr(sval0);

ns=4;  arn=0;  __rq=4;  __nxq=2;
let __bsk= 1 1 2 2;  __seesj=__bsk;
let __xqk=  0 -2  0
            0  1  0
            0  0  0
            2  0  0;

ns=6;  arn=0;  __rq=4;
let __bsk= 1 1 1  2 2 2;  __seesj=__bsk;
let __xqk=  0 -2  0   0  0
            0  0  1  -1  0
            0  0  2  -1  0
            0  0  0   0 -2
            3  0  0   0  0
            4  0  0   0  0;
 __nxq=maxc(__xqk);
call msmr(bs'|sees'|xq[1 1 2 2]);

ns=6;  arn=0;  __rq=4;
let __bsk= 1 1 1  2 2 2;  __seesj=__bsk;
let __xqk=  0 -2  0   0  0
            0  0 -1   0  0
            0  0  1  -1  0
            0  0  0   0 -2
            2  0  0   0  0
            3  0  0   0  0;
 __nxq=maxc(__xqk);
call msmr(bs[1 4]'|sees[1 4]'|xq[2 3 4]);

let sval0= -0.3477    0.9881    0.9137    0.7031    0.5852    0.0452    0.0652;

ns=2;  arn=2;  __rq=4.1; __oaralg=1;
let __bsk=0;  __seesj=0;
let __xqk=  1  0  0  0  -1  0  0
            2  0  0  0  -1  0  0
            0 -2  0  0   0  0  0
            0 -2  0  0   0  0  0

            0  0  0  0   0  0 -2
            0  0  0  0   0  0 -2
            0  0  0  3   0  0  0
            0  0  0  4   0  0  0;
 __nxq=maxc(__xqk);
sval0= vec(bs[1 4]')|sees[1 4]'|zeros(arn*ns,1)|1|xq[1 2 3];
call msmr(sval0);

let __xqk=  0  0  0  0  -1  0  0
            0  0  0  0  -1  0  0
            0 -2  0  0   0  0  0
            0 -2  0  0   0  0  0

            0  0  0  0   0  0 -2
            0  0  0  0   0  0 -2
            0  0  0  0   0  0  0
            0  0  0  1   0  0  0;
 __nxq=maxc(__xqk);
sval0= vec(bs')|sees'|vec(rhos')|0.025;
call msmr(sval0);


let sval0=  -1.6  0.8
             0.6  0.8
              0   .3
              0   .1
             .50 .50  .05 .05;
let __xqk=  1  0  0  0  -1  0  0
            2  0  0  0  -1  0  0
            0 -2  0  0   0  0  0
            0 -2  0  0   0  0  0

            0  0  0  0   0  0 -2
            0  0  0  0   0  0 -2
            0  0  0  3   0  0  0
            0  0  0  4   0  0  0;
 __nxq=maxc(__xqk);
call msmr(sval0);

let __xqk=  0  0  0  0  -1  0  0
            0  0  0  0  -1  0  0
            0 -2  0  0   0  0  0
            0 -2  0  0   0  0  0

            0  0  0  0   0  0 -2
            0  0  0  0   0  0 -2
            0  0  0  0   0  0  0
            0  0  0  1   0  0  0;
 __nxq=maxc(__xqk);

sval0= vec(bs')|sees'|vec(rhos')|0.025;
call msmr(sval0);


end;

let sval0=
  -1.5810    0.7969    0.5994    0.7470
  -0.7059    0.2750    0.0891    0.1119
   0.0247;

