/*  MSMP.ARC  MSM procs Michael Boldin (revised 5/96)   */
/*  all right reserved, this code may not be sold       */


proc lqov(Q);  local ns, dnlam, lqo;  ns=rows(Q);
 if ns==1; "ERROR ! -- rows(Q)=1"; lqo=0; endif;
 if ns .ne cols(Q); "ERROR ! --  Q matrix not square";
  elseif ns==2; lqo= (Q[2,1]~Q[1,2]) / (Q[2,1] + Q[1,2]);
  elseif ns >= 3;
    dnlam=(eye(ns-1) - (Q[1:ns-1,1:ns-1] - ones(ns-1,1)*Q[ns,1:ns-1]));
    lqo=Q[ns,1:ns-1]*inv(dnlam);  lqo=lqo~(1-sumc(lqo'));
 endif;
 retp(lqo);
endp;

proc rq(xq);   local nr, nc; nr=rows(xq); nc=cols(xq);
  xq=abs(xq);  xq=xq./(sumc(xq')*ones(1,nc));
  retp(xq);
endp;

proc xqtq(xq);
  local nc, j, Qc, Qn, Q; nc=cols(xq);
  j=1; Q= 1 ./ ( 1 + xq[.,j]^2);
  do until j==nc; j=j+1;
    Qc= 1 ./ ( 1 + xq[.,j]^2);
    Q= Q ~ ( (1 - sumc(Q')) .*  Qc );
  endo;
  retp(Q);
endp;

proc qtxq(Q);  local nr, nc, j, xq;
  nr=rows(Q); nc=cols(Q); xq=zeros(nr,nc);
  j=1; xq[.,j]=( (1./Q[.,j] - 1) )^(0.5);
  do until j==nc; j=j+1;
    xq[.,j]=(((1-sumc(Q[.,1:j-1]'))./Q[.,j])-1)^(0.5);
  endo;
  retp(xq);
endp;

proc (1)=rxq(xx);  retp(0);  endp;

proc (1)=restrq(xqq,nr,nc,xq0,xqk);
  local i, j, kk, xk, qq, xi;
  kk=0; xi=0;  qq=reshape(xq0,nr,nc);
  if maxc(vec(xqk))==1;  xi=1;  endif;
  i=0;  do until i==nr;  i=i+1;
  j=0;  do until j==nc-1;  j=j+1;
        kk=kk+1;  xk=xqk[kk];
        if xi ge 1 and xk==1;  xk=xi; xi=xi+1;  endif;
        if xk==0;  /* do nothing */
           elseif j ge 2 and  xk==-1;
              qq[i,j]=1-sumc(qq[i,1:j-1]');
              qq[i,j+1:nc]=reshape(0,1,nc-j);
           elseif xk==-2;   qq[i,j]=1;
           elseif xk ge 1;  qq[i,j]=xqq[xk];  endif;
  endo; endo;
  qq[.,nc]=1-sumc(qq[.,1:nc-1]');   Qq=rq(qq);
  retp(Qq);
endp;


proc esmp(ns,eon);  local j, sj, ens, esm;  sj=seqa(1,1,ns);
  ens=ns^eon; esm=zeros(ens,eon);
  j=0; do until j==eon; j=j+1;
    esm[.,j] =  vec ( reshape ( sj, ns^(j-1), ns^(eon-j+1) ) );
  endo;
 retp(esm);
endp;

proc zlmp(zls,ealsm);
  local j, arn, zlm, ls;
  arn=rows(zls); zlm=zeros(rows(ealsm),arn);
  j=0; do until j==arn; j=j+1;
     ls=ealsm[.,j];
     zlm[.,j]=zls[j,ls]';
  endo;
  retp(zlm);
endp;


proc esqp(exq,ns,eso);  local i, ei, j, ej, iqx, ii, ens, esQ;
 ens=ns^eso; esQ=zeros(ens,ens); i=0; ei=1; ej=0; iqx=1;
 if rows(exq) ne ens*(ns-1);
   "Error--  esqp(exq,ns,eso)";
   "  rows of exq = " rows(exq);
   "  should be (ns^eso)*(ns-1) = " ens*(ns-1);
 else;
    j=0; do until j==ens; j=j+1; ii=0;
       if j le ens-ns^(eso-1);
          esQ[ei:ei+ns-1,j]=exq[iqx:iqx+ns-1]; iqx=iqx+ns;
          ei=ei+ns;  if ei gt ens; ei=1; endif;
       else;  esQ[ei:ei+ns-1,j]=1-sumc(esQ[ei:ei+ns-1,.]');  ei=ei+ns;
       endif;
    endo;
 endif;
 retp(esQ);
endp;

proc eaqm(Q,ean);   local j, ns, reasl, eaq;
    ns=rows(Q);    reasl=ns^ean;  eaq=zeros(reasl,ns);
    j=0;  do until j==ns; j=j+1;
      eaq[.,j]= vec(reshape(Q[.,j]',ns^(ean-1),ns));
    endo;
   retp(eaq);
endp;

proc leaqov(Q,ean);
  local ei, ej, i, j, ns, reasl, easl, lqo, leaqo;
    ns=rows(Q);   reasl=ns^ean;  easl=esmp(ns,ean);
    lqo=lqov(Q);  ei=easl[.,1];  leaqo=lqo[ei]';
    i=0;  do until i==reasl;  i=i+1;
      j=0;  do until j==ean-1;  j=j+1;
        ei=easl[i,j];  ej=easl[i,j+1];
        leaqo[i]=leaqo[i].*Q[ei,ej];
      endo;
    endo;
 retp(leaqo);
endp;

proc leaqoc(eaq,xx);
  local i, i1, nrx, ncx, lex, lex1, dlex;
  nrx=rows(eaq);  ncx=cols(eaq);  i1=ones(1,ncx);  dlex=1;
  if rows(xx)==nrx and cols(xx)==1;  lex=xx;
     else;  lex=ones(nrx,1)/nrx;  endif;
  i=0;  do until i==100 or dlex le 1e-8;  i=i+1;
     lex1=lex;
     lex=(lex*i1).*eaq;  lex=sumc(reshape(lex',nrx,ncx)');
     lex=(lex*i1).*eaq;  lex=sumc(reshape(lex',nrx,ncx)');
     lex=(lex*i1).*eaq;  lex=sumc(reshape(lex',nrx,ncx)');
     dlex=sumc(abs(lex-lex1));
  endo;
  retp(lex);
endp;

proc (0) = prvofp;
  locate 24-4,1;  format /ro 14,8;  -(vof+lnlvadd)  lnlv0;
endp;

proc clnlv(vlpt);
  if vlpt <  1/vofa; vof=vofa; vofa=vofa/10;
     else;  vof=(-1)*ln(vlpt);  endif;
  if prvof==1; call prvofp; endif;
 retp(vof);
endp;


proc (3) = smestp(ns,dsn,ys,Xs);
 local j, k, yj, Xj, usj, tns;
   local Bs, sdes;
   tns=zeros(1,ns);
   j=0; k=cols(Xs);
   Bs=zeros(k,ns); sdes=zeros(1,ns);
   do until j == ns;  j=j+1;
     yj=selif(ys,(dsn .eq j));  Xj=selif(Xs,(dsn .eq j));
     tns[j]=rows(yj); if yj == miss(0,0); tns[j]=0; endif;
     if tns[j] ge k+1;
       Bs[.,j]=inv(Xj'Xj)*Xj'yj;
       usj=yj-Xj*Bs[.,j];  sdes[j]=sqrt((usj'usj)/tns[j]);
     endif;
   endo;
 retp(bs,sdes,tns);
endp;

proc Qestp(dsn,ns);
 local Q, jr, jc, dsjc, dsjr;
   q=zeros(ns,ns-1);  jr=0;
   do until jr == ns;  jr=jr+1;  jc=0;
     dsjr=dsn[1:nobs-1,1] .eq jr;
     do until jc == ns-1;  jc=jc+1;
       dsjc=dsn[2:nobs,1] .eq jc;
       Q[jr,jc]=dsjc/dsjr;
     endo;
   endo;
   Q=q~(1-sumc(q'));
 retp(Q);
endp;

proc cspsm(Fs,Q,lto);
  local Tn, ns, j1, plf, ps, t;
  Tn=rows(Fs);       ns=cols(Fs);
  lto=lqov(Q);       j1=ones(ns,1);
  plf=zeros(tn,ns);  ps=zeros(tn,ns);
  t=1;   plf[t,.] = lto .* Fs[t,.];
  ps[t,.] = plf[t,.] / sumc(plf[t,.]');
  do until t == Tn;   t=t+1;
     plf[t,.]=(ps[t-1,.]*Q) .* Fs[t,.];
     ps[t,.]=plf[t,.] / sumc(plf[t,.]');
  endo;
  retp(ps);
endp;

proc fspsm(Fs,Q,lto);
  local Tn, ns, j1, az, j, t, plp, lpt, Mt, fsps;
  Tn=rows(Fs);          ns=cols(Fs);
  j1=ones(ns,1);        az=zeros(1,ns);
  fsps=zeros(Tn,ns-1);
  j=0;
  do until j == ns-1;   t=1;
   j=j+1;               plp=az;
   lpt=lto .* Fs[t,.];   plp[t,j] = lpt[1,j];
   do until t == Tn;    t=t+1;
    Mt=(Q .* (j1 * Fs[t,.]));
    plp=plp * Mt;       lpt=lpt * Mt;
    plp=plp|az;         plp[t,j] = lpt[1,j];
   endo;
   fsps[.,j]=sumc(plp');
  endo;
  fsps=fsps ./ sumc(lpt');
  fsps=fsps~(1-sumc(fsps'));
 retp(fsps);
endp;

proc stselv(Fs,Q,lto);
  local Tn, ns, j1, j, splf, pp, sclst;
  local t, jns, sl, s, jp, stemp, sst, jtb, mi;
  Tn=rows(Fs);     ns=cols(Fs);
  j1=ones(ns,1);  splf=zeros(Tn,ns);
  s=zeros(Tn,1);  jns=seqa(1,1,ns)';  sl=s;
  sst=ones(Tn,1)*jns;   sclst=zeros(Tn,1);
    t=1;
    splf[t,.] = lto[1,.] .* Fs[t,.];
    do until t == Tn;    t=t+1;
     pp=Q.*(splf[t-1,.]'*j1');
     jp=maxindc(pp)';
     splf[t,.]=Fs[t,.].*maxc(pp)';
     stemp=sst[1:t-1,.];
     j=0;
     do until j == ns;   j=j+1;
      jtb=jp[1,j];
      if jtb /= j;   sst[1:t-1,j]=stemp[.,jtb];  endif;
     endo;
    endo;
    mi=maxindc(splf[Tn,.]');  sclst=sst[.,mi];
 retp(sclst);
endp;

proc mfarnm(z,stds,arn,rhom);
 local t, esl, ns, narnr, jtl, tn, ei, sigmas, ZL, ut, ft, farn;
  local rrhom; rrhom=rev(rhom);
  local zck;    zck=0;
  ns=cols(z);          tn=rows(z);
  esl=esmp(ns,arn);    narnr=ns^arn;      ei=esl[.,arn];
  jtl=seqa(1,1,arn);
  farn=ones(tn,ns^(arn+1));
  sigmas=ones(narnr,1)*stds;
  local ens, esl1, l1;   ens=ns^arn; esl1=seqa(1,ns,ens/ns); l1=ones(ens,1);
  t=arn+1;
  if arn ge 2;
     ZL = zlmp(rev(z[t-jtl,.]),esl);
     ut = ones(narnr,1)*z[t,.] - (ZL * rrhom);
    elseif arn == 1  and  __ar1m==1;
     ZL = z[t-1,.]' * ones(1,ns);
     ut = ones(narnr,1)*z[t,.] - (ZL .* rhom);
    else;
     ZL = zlmp(z[t-jtl,.],esl);
     ut = ones(narnr,1)*z[t,.] - (ZL * rhom);
  endif;
  ft=pdfn(ut./sigmas) ./ sigmas;
  farn[t,.]=vec(ft)';
  do until t == tn;    t=t+1;
    if arn gt 1;
      ZL=(reshape(zl[esl1,2:arn],narnr,arn-1)~z[t-1,ei]');
      ut=ones(narnr,1)*z[t,.] - (ZL * rrhom);
    else;
     if __ar1m==1;
        ZL = z[t-1,.]' * ones(1,ns);
        ut = ones(narnr,1)*z[t,.] - (ZL .* rhom);
     else;
        ZL = z[t-1,ei]';
        ut=ones(narnr,1)*z[t,.] - (ZL * rhom);
     endif;
    endif;
    ft=pdfn(ut./sigmas) ./ sigmas;
    farn[t,.]=vec(ft)';
  endo;
 retp(farn);
endp;


proc (2) = mfarnm2(z,stds,arn,rhom);
 local t, esl, ns, narnr, jtl, tn, ei, sigmas, ZL, ut, ft, farn, es;
 local rrhom; rrhom=rev(rhom);
  local zck;    zck=0;
  ns=cols(z);          tn=rows(z);
  esl=esmp(ns,arn);    narnr=ns^arn;      ei=esl[.,arn];
  jtl=seqa(1,1,arn);
  farn=ones(tn,ns^(arn+1));
  es=zeros(tn,ns^(arn+1));
  sigmas=ones(narnr,1)*stds;
  local ens, esl1, l1;   ens=ns^arn; esl1=seqa(1,ns,ens/ns); l1=ones(ens,1);

  t=arn+1;
  if arn ge 2;
     ZL = zlmp(rev(z[t-jtl,.]),esl);
     ut = ones(narnr,1)*z[t,.] - (ZL * rrhom);
    elseif arn == 1  and  __ar1m==1;
     ZL = z[t-1,.]' * ones(1,ns);
     ut = ones(narnr,1)*z[t,.] - (ZL .* rhom);
    else;
     ZL = zlmp(z[t-jtl,.],esl);
     ut = ones(narnr,1)*z[t,.] - (ZL * rhom);
  endif;
  ft=pdfn(ut./sigmas) ./ sigmas;
  farn[t,.]=vec(ft)';   es[t,.]=vec(ut)';
  do until t == tn;
    t=t+1;
    if arn gt 1;
      ZL=(reshape(zl[esl1,2:arn],narnr,arn-1)~z[t-1,ei]');
      ut=ones(narnr,1)*z[t,.] - (ZL * rrhom);
    else;
     if __ar1m==1;
        ZL = z[t-1,.]' * ones(1,ns);
        ut = ones(narnr,1)*z[t,.] - (ZL .* rhom);
     else;
        ZL = z[t-1,ei]';
        ut=ones(narnr,1)*z[t,.] - (ZL * rhom);
     endif;
    endif;
    ft=pdfn(ut./sigmas) ./ sigmas;
    farn[t,.]=vec(ft)';   es[t,.]=vec(ut)';
  endo;
 retp(farn,es);
endp;

proc mfsparm(farn,esq,expo,ns,arn);
 local fspa, jns, narnr, ej, sej;
   narnr=ns^arn;
   jns=seqa(1,1,ns);
   ej=vec(reshape(jns,narnr,ns));
   sej=dummybr(ej,jns);
   fspa=fspsm(farn,esq,expo);
 retp(fspa*sej);
endp;

