/*  MSMR2.ARC   Markov Switching Model Program         */
/*  Michael Boldin  4/22/93   ammended  5/20/96        */
/*  all right reserved, this code may not be sold      */

proc (0) = opttbl(bh,bhse,likval,otitle); endp;
proc (0) = marset;  endp;

proc (0)=msminit;
  ns=2;     __mbhn=0;   __msmfn=0;
  __bsk=0;  __nxbs=0;   __seesj=0;  __nxsees=0;
  arn=0;    __rhosx=0;  __nxrhos=0;
  __ar1m=0;  __arnns=0;  __oaralg=0;
  __rq=1;   __nxq=0;    __noqp=0;   __nxpo=0;   __po=0;
  __prvof=1;  __output=2;  __mtbl=2;  __smtabl=0;
endp;


proc (0) = msmset;
  vofa=1e250;    retcode=0;    vofadj=exp(lnlvadd);
  k=cols(X);     tn=rows(y);   firstt=__ftt;  lastt=__ltt;
  if ddates==0;  ddates=seqa(1,1,tn);  endif;
  zs=miss(ones(tn,ns),1);   Fs=zs;
  if firstt==0;  firstt=arn+1;
     elseif firstt lt arn+1;  firstt=arn+1;  endif;
  if lastt==0;  lastt=tn;  endif;
  nobs=lastt-firstt+1;
  jns=seqa(1,1,ns);  i1=ones(1,ns);  j1=ones(ns,1);
  nxbs=0; nxsees=0; nxrhos=0; nxq=0; nxpo=0;  nxparam=0;
  if __nxbs ne 0;  nxbs=__nxbs;
     elseif __bsk ne 0;  nxbs=maxc(vec(__bsk));
     else; nxbs=ns*k;  endif;
  if __nxsees ne 0;  nxsees=__nxsees;
     elseif __seesj ne 0; nxsees=maxc(vec(__seesj));
     else; nxsees=ns;  endif;
  if arn gt 0;  call marset;  endif;
  if __nxq ne 0;  nxq=__nxq;
     else; nxq=ns*(ns-1);  endif;
  if __po==0 or __po==-1;  nxpo=0;
     elseif __nxpo ne 0;  nxpo=__nxpo;
     else;  nxpo=ns-1;  endif;
  nxparam= nxbs + nxsees + nxrhos +  nxq + nxpo;
endp;


proc (0)=marset;  local nk;
  oaralg=__oaralg; if arsize==1; oaralg=1; endif;
  sj=seqa(1,1,ns); arj=seqa(1,1,arn);
  ens=ns^arn; esl1=seqa(1,ns,ens/ns); l1=ones(ens,1);
  ealsm=esmp(ns,arn);   ei1=ones(ens,1);
  arsize=0;  nk= ns^(2*(arn+1));
  if nk gt __mlimit;  arsize=1;
     else;  arsize=0;  esm=esmp(ns,arn+1); endif;
  if __arnns==1 and __rhosx==0; __rhosx=1.1;  endif;
  if arn==1;  nxrhos=ns;
     if __ar1m==0 and __rhosx==0 and __rhosj==0;  nxrhos=ns;
        elseif __rhosx==1.1;  nxrhos=1;
        elseif __ar1m==1 and __rhosj==0;  nxrhos=ns*ns;
        elseif __ar1m==2 and __rhosj==0;  nxrhos=ns;
        elseif __rhosj ne 0;  nxrhos=maxc(vec(__rhosj));
     endif;
  else;  nxrhos=ns*arn;
     if __rhosx==0 and __rhosj==0;  rhoxns=ns;  nxrhos=arn*rhoxns;
        elseif __rhosx==1.1;  rhoxns=1;  nxrhos=arn;
        elseif __rhosj ne 0;  rhoxns=maxc(vec(__rhosj));
                              nxrhos=arn*rhoxns;
     endif;
  endif;
  if __nxrhos ge 1; nxrhos=__nxrhos;  endif;
endp;


proc (0)=msmr(sval0);

  local oalg, mtbl2, sdate, vv, vtime1, vtime2, xxesq;
  local msmfn, xfn;  xfn=0;

   if __msmfn == 0;   xfn=0;
      elseif __msmfn $/= "";  xfn=1;
      msmfn = VARGET("__msmfn");
      local msmfn:proc;
   endif;

   call msmset;
   bh=0; g=0; bhse=0;
   oalg=oaralg;
   prvof=0;  mtbl2=__mtbl;

   if nxparam ne rows(sval0);
      output on; print;
      $Mtitle;
      format /rd 9,6;
      "*** Problem with Starting Values ***";
       print /rd  sval0';
      "Rows-- " rows(sval0)  "  & "  nxparam " needed";
      print;  output off;

   else;  /* OK to run */
      output on; print; format /rd 9,6;
      $Mtitle;  "Starting Values "; print /rd  sval0';

      if xfn==1;   vof0=msmfn(sval0);
         elseif arn eq 0; vof0=msmofn(sval0);
         elseif arn eq 1; vof0=msmoar1(sval0);
         elseif (arn ge 2 and oalg==0);
            sdate=date;
            oaralg=1; vof0=msmoar(sval0); vtime1=ethsec(sdate,date);
            sdate=date;
            oaralg=2; vv=msmoarn(sval0);  vtime2=ethsec(sdate,date);
            if vtime1 le vtime2; oalg=1;
               else;  oalg=1;  vof0=vv;  endif;
         elseif (arn ge 2 and oalg==1);  vof0=msmoar(sval0);
         elseif (arn ge 2 and oalg==2);  vof0=msmoarn(sval0);
         else;  oaralg=2;  vof0=msmoarn(sval0);
         oaralg=oalg;
      endif;

      lnlv0=-(vof0+ln(vofadj));
      print /rd "LnLv(sval0) "  lnlv0;  print;

      output off;  prvof=__prvof;
      if __outit==1;  output on;  endif;
      if xfn==1;  { bh,vof,g,retcode }=optmiz(&msmfn,sval0);
         elseif arn==0; { bh,vof,g,retcode }=optmiz(&msmofn,sval0);
         elseif arn==1; { bh,vof,g,retcode }=optmiz(&msmoar1,sval0);
         elseif (arn ge 2 and oalg==1); oaralg=1;
               { bh,vof,g,retcode }=optmiz(&msmoar,sval0);
         else; oaralg=2; { bh,vof,g,retcode }=optmiz(&msmoarn,sval0);
      endif;
      oaralg=oalg;
      lnlv=-(vof+ln(vofadj));
      prvof=0;

      if __outtbl==1;  output on;  call opttbl(bh,bhse,lnlv,mtitle);
         if mtbl2==2; call msmtbl2(bhse);
            elseif mtbl2==1;  call msmtbl; endif;
         print; print;
         if __smtabl==1;
              xxesq=__esq;
         /*   if arn ge 2 and oalg == 2; __esq=1;  endif; */
             { Fsy,mlsy,fspy } = smtabl(ddates,firstt,lastt,0);
             __esq=xxesq;
         endif;
      endif;

   endif;
   output off;  print;


endp;


proc (0) = opttbl(bh,bhse,lnlv,otitle);
 local  seciter, np, bxo, mask, fmt;
   seciter= 60*(_opitdta[2]/_opitdta[1]);
   $otitle;
   format /rd 9,2;
   if _op_ver[1,1] ge 2;
   print /rd "OPTMUM Results  " $datestr(date) "   " $timestr(time);
   format /rd 7,0;  "   Iterations  - "  _opitdta[1];
   format /rd 9,2;  "   Minutes     - "  _opitdta[2]
                         " ("  seciter  " sec/iter)";
   if retcode==0;  print "   Return Code -  OK";
      elseif retcode==1;
      "   Problem Return Code - " retcode  " ** Forced Exit";
      elseif retcode==2;
      "   Problem Return Code - " retcode  " ** Max Iterations at " _opmiter;
      elseif retcode==10;
      "   Problem Return Code - " retcode  " ** Hessian problem ";
      else; format /ro 5,1;  "   Problem Return Code - " retcode;  endif;
   else;
   print /rd "ML Estimation Results  " $datestr(date) "   " $timestr(time);
   endif;
   print;
   format /rd 12,6;
   if  (-.1  le lnlv) and (lnlv le  .1);
            print /ro "LnLik     "  lnlv;
     else;  print /rd "lnLik     "  lnlv;  endif;

   np=rows(bh);  mask=ones(1,5);
   if rows(bhse) ne np;  bhse=reshape(miss(0,0),np,1);  endif;
   if rows(g) ne np;  g=reshape(miss(0,0),np,1);  endif;
   bxo=seqa(1,1,np)~bh~bhse[.,1]~(bh./bhse[.,1])~g[.,1];
   let fmt[5,3] = "*.*lf"  4  0
                  "*.*lf"  9  4
                  "*.*lf"  9  4
                  "*.*lf"  9  4
                  "*.*lf"  9  4;
   print " Var  Parameter    se      t       grad";
   print "------------------------------------------";
   call printfm(bxo,mask,fmt);  print;
   format /rd 9,4;
endp;

end;
