/*  MSMTBLN.ARC  MSM Tables for results                 */
/*  Michael Boldin (revised 5/96)                       */
/*  all right reserved, this code may not be sold       */


proc 0=msmtbl;
 local sj, lab, nr, j;
 local mask, fmta, fmtb, fmtx, fmt, fmx, lpr;
 local __iv;  __iv=0;
 if (indvar ne 0) and (indvar ne miss(0,0));
     if (rows(vec(indvar)) == rows(Bs));  __iv=1;  endif;
 endif;

   print;  format /rd 9,0;
   sj=seqa(1,1,ns)';  let lab=" -------";
   "          "  "  Regimes";
   "          "  $reshape(lab,1,ns);
   "       "  sj;
   "          "  $reshape(lab,1,ns);
   format /rd 9,4;

   nr=rows(Bs);
   if __iv==1;
     mask=0~ones(1,ns);
     let fmta= "-*.*s"  9  9;  let fmtb= "*.*lf" 10  4;
     fmt= fmta' | reshape(fmtb,ns,3);
     fmx= vec(indvar)~Bs;  lpr=printfm(fmx,mask,fmt);  print;
   else;
     "Bs        "  Bs[1,.];
     if nr gt 1;
        j=1; do until j==k; j=j+1; "          "  Bs[j,.];  endo;
     endif;
   endif;   print;

   "Sees      "  sees;  print;

   if arn == 1;  nr=rows(ar1m);
   "AR1m      "  Ar1m[1,.];
   if nr ge 2;
   j=1; do until j==nr; j=j+1;
   "          "  Ar1m[j,.];
   endo;
   endif;  print;
   endif;

   if arn ge 2;  nr=rows(rhos);
   "Rhos      "  rhos[1,.];
   if nr ge 2;
   j=1; do until j==nr; j=j+1;
   "          "  rhos[j,.];
   endo;
   endif;  print;
   endif;

   if __noqp==0  or  (__rq==4 or __rq==4.1 or __rq==4.2) or __nxq ne 0;
   "xq        "  xq[1,.];
   j=1; do until j==nxq; j=j+1;
   "          "  xq[j,.];
   endo; print;
   endif;
   if __noqp ne 0  and  __rq le 3;
   "Q         "  Q[1,.];
   j=1; do until j==ns; j=j+1;
   "          "  Q[j,.];
   endo; print;
   endif;

   "lqo       "  lqo;  print;
   "po        "  po;   print;

   "lnLik         "  lnlv;
   "Obs.          "  nobs;
   print;

endp;

proc (0)= msmtbl2(xse);
  local lrx, nxc, lxn,
        seBs, sesdes, serho, seQ, seqx, sepo,
        jns, mask, fmta, fmtb, fmt, fmt1, bc, bca, sc, selab,
        j, lab, fmx, lpr, rfmt, rmask, rca, rc, qc, Qca, jk;
  local  Bs_se, sees_se, rhos_se, xq_se, xpo_se, ar1m_se;
  local  xqx, xq2, nxqx;
  local  fmt2, mask2, lab_x, lab_se;
  local  fxn, rxse, nshould;

  local  __printq, noses, mv, mvx;
  __printq=0;  xpo_se=0;  noses=0;  mv=miss(0,0);

  local __iv;  __iv=0;
  if (indvar ne 0) and (indvar ne miss(0,0));
     if (rows(vec(indvar)) == rows(Bs));  __iv=1;  endif;
  endif;

   nshould= nxbs + nxsees + (arn ge 1)*nxrhos + nxq + nxpo;
   rxse=rows(xse);
   if xse==0;  noses=1;
      elseif xse==1;  xse=vec(bhse);
      elseif xse==2;  xse=sqrt(abs(diag(h)));
      elseif xse $== mv;  xse=reshape(mv,nshould,1);
      elseif rxse==cols(xse);  xse=sqrt(abs(diag(xse)));
   endif;
   if rxse ge 2 and rxse lt nshould and cols(xse)==1;
      xse=xse|reshape(mv,nshould-rxse,1);  endif;
  rxse=rows(xse);  lxn=nxbs;
  if noses==0;
     Bs_se=xse[1:lxn];  Bs_se=reshape(Bs_se[__bsk],k,ns);
     fxn=lxn+1; lxn=fxn+nxsees-1; sees_se=abs(xse[fxn:lxn])';
     if __nxsees==1; sees_se=reshape(sees_se,1,ns);
        elseif nxsees ne ns; sees_se=sees_se[__seesj];  endif;
     if arn == 1; fxn=lxn+1; lxn=fxn+nxrhos-1;  ar1m_se=xse[fxn:lxn];
        if __shprho==0 and __arnns ne 1; ar1m_se=ar1mp(ar1m_se);
           elseif __arnns==1;  ar1m_se=ar1m_se[1,1];
           elseif arn==1 and __shprho==1;  ar1m_se=rhoshape(ar1m_se);
        endif;
     elseif arn ge 2; fxn=lxn+1; lxn=fxn+nxrhos-1;  rhos_se=xse[fxn:lxn];
        if __shprho==0; rhos_se=rhop(rhos_se);
           elseif arn ge 2 and __shprho==0;
                  rhos_se=rhoshape(rhos_se); endif;
     endif;
     fxn=lxn+1;lxn=fxn+nxq-1; xq_se=xse[fxn:lxn];
     if __po ge 1;  xpo_se=xse[lxn+1:rxse]';  endif;
  endif;

  format /rd 8,8;
  print /ro "Depvar: "  $depvar;  print;
  "          "  " Regimes";

  mask=zeros(1,ns+1);
  let fmta= "-*.*s" 8 8;   let fmtb= "*.*s"  9  9;
  fmt= fmta' | reshape(fmtb,ns,3);
  let lab="------";   fmx=("    ")~reshape(lab,1,ns);

  lpr=printfm(fmx,mask,fmt);  print;
  format /rd 8,0;
   print /rd "        "  seqa(1,1,ns)';
  lpr=printfm(fmx,mask,fmt);  print;
  format /rd 8,4;

  let lab_se="   se";
  mask=0~ones(1,ns);
  let fmta= "-*.*s"  8  8;   let fmtb= "*.*lf"  9  4;
  fmt= fmta' | reshape(fmtb,ns,3);
  format /ro 9,4;

  j=0;  do until j==k;  j=j+1;
    if rows(indvar)==k and __iv==1;  lab_x=indvar[j];
       else;  lab_x="B" $+ ftocv(j,1,0) $+ "s";  endif;
    if noses==1; fmx= lab_x~Bs[j,.];
       else;  fmx= (lab_x|lab_se)~(Bs[j,.]|Bs_se[j,.]);  endif;
    lpr=printfm(fmx,mask,fmt);  print;
  endo;
  if noses==1; print; endif;

  let lab_x="sees";
  if noses==1; fmx= lab_x~sees;
     else;  fmx= (lab_x|lab_se)~(sees|sees_se);  endif;
  lpr=printfm(fmx,mask,fmt);  print;
  if noses==1; print; endif;

  if arn==1;  lab_x="AR1";   mvx=reshape(mv,1,ns-1);
     if __ar1m==0 and __nxrhos==0;   /* regular case */
        if noses==1;  fmx= lab_x~ar1m[1,.];
           else;  fmx= (lab_x|lab_se)~(ar1m[1,.]|ar1m_se[1,.]);  endif;
        lpr=printfm(fmx,mask,fmt);  print;
     elseif __ar1m==1 and nxrhos==1;   /* one parameter case */
        if noses==1;  fmx= lab_x~ar1m[1,.];
           else;  fmx= (lab_x|lab_se)~(ar1m[1,.]|(ar1m_se[1,.]~mvx)); endif;
        lpr=printfm(fmx,mask,fmt);  print;
     elseif __ar1m==1 and nxrhos==ns*ns;   /* full matrix case */
        lab_x="AR1m";
        if noses==1;  fmx= lab_x~ar1m[1,.];
           else;  fmx= (lab_x|lab_se)~(ar1m[1,.]|ar1m_se[1,.]); endif;
        lpr=printfm(fmx,mask,fmt);  print;
        j=1;  do until j==ns; j=j+1;
        if noses==1;  fmx= ("  ")~ar1m[j,.];
           else;  fmx= ("  "|lab_se)~(ar1m[j,.]|ar1m_se[j,.]); endif;
           lpr=printfm(fmx,mask,fmt);  print;
        endo;
     elseif __ar1m==2 and nxrhos==ns;   /* diagonal case */
        lab_x="AR1m";   mvx=reshape(mv,1,ns);
        if noses==1;  fmx= lab_x~ar1m[1,.];
           else;  mvx[1]=ar1m_se[1,1];
                  fmx= (lab_x|lab_se)~(ar1m[1,.]|mvx);  endif;
        lpr=printfm(fmx,mask,fmt);  print;
        j=1;  do until j==ns; j=j+1;  lab_x="   "; mvx=reshape(mv,1,ns);
        if noses==1;  fmx= lab_x~ar1m[j,.];
           else;  mvx[j]=ar1m_se[j,j];
                  fmx= (lab_x|lab_x)~(ar1m[j,.]|mvx);  endif;
           lpr=printfm(fmx,mask,fmt);  print;
        endo;
     elseif __ar1m==2 and nxrhos==1;   /* diagonal/one parameter case */
        lab_x="AR1m";   mvx=reshape(mv,1,ns);
        if noses==1;  fmx= lab_x~ar1m[1,.];
           else;  mvx[1]=ar1m_se[1,1];
                  fmx= (lab_x|lab_se)~(ar1m[1,.]|mvx);  endif;
        lpr=printfm(fmx,mask,fmt);  print;
        j=1;  do until j==ns; j=j+1;  lab_x="   "; mvx=reshape(mv,1,ns);
        if noses==1;  fmx= lab_x~ar1m[j,.];
           else;  fmx= (lab_x|lab_x)~(ar1m[j,.]|mvx);  endif;
           lpr=printfm(fmx,mask,fmt);  print;
        endo;
     else;   /* other casea */
        lab_x="AR1m";
        fmx= lab_x~ar1m[1,.];
        lpr=printfm(fmx,mask,fmt);  print;
        j=1;  do until j==ns; j=j+1;  lab_x="   ";
              fmx= lab_x~ar1m[j,.];
              lpr=printfm(fmx,mask,fmt);  print;
        endo;
     endif;
     print;
  endif;

  if arn gt 1;
     j=0;  do until j==arn; j=j+1; lab_x="rho" $+ ftocv(j,1,0) $+ "s";
         if noses==1;  fmx= lab_x~rhos[j,.];
            else;  fmx= (lab_x|lab_se)~(rhos[j,.]|rhos_se[j,.]);  endif;
         lpr=printfm(fmx,mask,fmt);  print;
     endo;
     print;
  endif;

  if noses==0;
  if __noqp==0 and (__rq==0 or __rq==1) and nxq==ns*(ns-1);
     __printq=0;
     xq_se=reshape(xq_se,ns,ns-1);
     let Qca="q";  let sc="s";
     j=0; do until j==ns; j=j+1;
        jk=ftocv(j,1,0);   Qc=Qca $+ jk $+ sc;
        lab=Qc|lab_se;     fmx=lab~( Q[j,.]|(xq_se[j,.]~mv) );
        lpr=printfm(fmx,mask,fmt); print;
     endo;
  elseif  __noqp==0 and (__rq == 2 and nxq==ns*(ns-1));
    __printq=1;
    xq2=reshape(xq,ns,ns-1);  xq_se=reshape(xq_se,ns,ns-1);
    let Qca="xq";  let sc="s";
    j=0; do until j==ns; j=j+1;
        jk=ftocv(j,1,0);   Qc=Qca $+ jk $+ sc;
        lab=Qc|lab_se;     fmx=lab~( xq2[j,.]|xq_se[j,.] );
        fmt2= fmta' | reshape(fmtb,cols(fmx)-1,3);
        mask2=0~ones(1,cols(fmx)-1);
        lpr=printfm(fmx,mask2,fmt2); print;
    endo;
  else;   __printq=1;  xqx=vec(xq');  nxqx=rows(xqx);
    let Qca="xq";
    j=0; do until j==nxqx; j=j+1;
        jk=ftocv(j,1,0);   Qc=Qca $+ jk;
        lab=Qc|lab_se;     fmx=lab~(xqx[j]|xq_se[j]);
        fmt2= fmta' | reshape(fmtb,cols(fmx)-1,3);
        mask2=0~ones(1,cols(fmx)-1);
        lpr=printfm(fmx,mask2,fmt2); print;
    endo;
  endif;
/* for other cases for xq output */
  else;   xqx=vec(xq');  nxqx=rows(xqx);
    let Qca="xq";
    j=0; do until j==nxqx; j=j+1;
        jk=ftocv(j,1,0);   Qc=Qca $+ jk;
        lab=Qc;     fmx=lab~xqx[j];
        fmt2= fmta' | reshape(fmtb,cols(fmx)-1,3);
        mask2=0~ones(1,cols(fmx)-1);
        lpr=printfm(fmx,mask2,fmt2); print;
    endo;
    print;
  endif;
  if arn ge 1;  print;  endif;

  if  __noqp==0  and  (noses==1  or __printq==1) and __rq lt 4;
    j=0; do until j==ns; j=j+1;
        if j==1; lab="Q";  else; lab=" ";  endif;
        fmx=lab~Q[j,.];
        lpr=printfm(fmx,mask,fmt); print;
    endo; print;
  endif;

  if cols(po)==ns and cols(lqo)==ns;
  if __po==1 and xpo_se ne 0;
     lab="po"|lab_se;   fmx=lab~(xpo|xpo_se);
     fmt2= fmta' | reshape(fmtb,cols(fmx)-1,3);
     mask2=0~ones(1,cols(fmx)-1);
     lpr=printfm(fmx,mask2,fmt2); print;
     fmx="lqo"~lqo; lpr=printfm(fmx,mask,fmt);
  elseif __po==2 and xpo_se ne 0;
     lab="xpo"|lab_se;   fmx=lab~(xpo|xpo_se);
     fmt2= fmta' | reshape(fmtb,cols(fmx)-1,3);
     mask2=0~ones(1,cols(fmx)-1);
     lpr=printfm(fmx,mask2,fmt2); print;
     fmx="po"~po; lpr=printfm(fmx,mask,fmt); print;
     fmx="lqo"~lqo; lpr=printfm(fmx,mask,fmt);
  elseif __po ne 0 and xpo_se==0;
     fmx="po"~po; lpr=printfm(fmx,mask,fmt);
     fmx="lqo"~lqo; lpr=printfm(fmx,mask,fmt);
  elseif __po==0;
     fmx="po=lqo"~po; lpr=printfm(fmx,mask,fmt);
  else;
     fmx="po"~po; lpr=printfm(fmx,mask,fmt);
     fmx="lqo"~lqo; lpr=printfm(fmx,mask,fmt);
  endif;
  endif;
  print; print;

  format /rd 9,4;
  if  (-.1  le lnlv) and (lnlv le  .1);
            print /ro "LnLik     "  lnlv;
     else;  print /rd "lnLik     "  lnlv;  endif;
  print /ro           "Obs.      "  nobs; print;

endp;




proc (3) = smtabl(ddates,ftt,ltt,vuse);
 local fmt, mask, fmx;
 local narnr, esln, expo, eaqx;
 local nrows, nrt, sdate, enns, stselv2, j;
 local CSJ, CSEJ, NSEJ, CST, FSTT, LSTT, FDATE, LDATE, STAY;
 local zsa, fsa, fspt, vs, vst;
 local mlsa, tt, t, yst, zst, farsa, fspa, fspara, mlsara;

  mlsa=0; fspa=0;
  zsa=y-X*Bs;
  nrows=rows(zsa);

 if arn == 0;
   if ltt==0 or ftt==0;  ftt=1;  ltt=nrows;  endif;
   fsa=pdfn(zsa./sees)./sees;
   Fsa=Fsa[ftt:ltt,.];
   mlsa = stselv(Fsa,Q,po);
   Fspa=fspsm(Fsa,Q,po);

 elseif arn ge 1;
  if ltt==0 or ftt==0;  ftt=1+arn;  ltt=nrows;  endif;
  narnr=ns^arn;   esln=esmp(ns,arn+1);   enns=rows(esq);
  if __esq==0;   eaqx=eaqm(Q,arn+1);
      esQ=esqp(vec(eaqx[.,1:ns-1]),ns,arn+1);  expo=lqov(esq);
  endif;
  if __po==0;   expo=lqov(esq); endif;
  if __po==-1;  expo=ones(1,enns)/enns; endif;

  csj=esln[.,arn+1];      csej=dummybr(csj,jns);
  nsej=seqa(1,1,rows(csj));

  farsa=mfarnm(zsa,sees,arn,rhos[1:arn,.]);
  farsa=farsa[ftt:ltt,.];
  mlsara = stselv(farsa,esq,expo);
  mlsa=(mlsara .== nsej')*csj;

  fspara = fspsm(farsa,esq,expo);
  fspa=fspara*csej;

 endif;

  format 7,3;
  mask=ones(1,12);
  let fmt[12,3]=  "*.*lf"  8  2
                  "*.*lf"  8  2
                  "*.*lf"  3  0
                  "*.*lf"  4  0
                  "*.*lf"  7  3
                  "*.*lf"  7  3
                  "*.*lf"  7  3
                  "*.*lf"  7  3
                  "*.*lf"  7  3
                  "*.*lf"  7  3
                  "*.*lf"  7  3
                  "*.*lf"  7  3;
 print;
 outwidth 132;

 if rows(vuse)==1;  vs=y*ones(1,ns);
    "                         Dep var                    "\
    "  Full Sample Probabilities";
 elseif (vuse==0 or rows(vuse) ne nrows);  vs=zsa;
    "                         Error term                "\
    "  Full Sample Probabilities";
 elseif (rows(vuse) eq nrows) and (cols(vuse) eq ns); vs=vuse;
    "                         Vuse var                  "\
    "  Full Sample Probabilities";
 else;  vs=reshape(vuse,ns,nrows)';
    "                         Vuse var                  "\
    "  Full Sample Probabilities";
 endif;
"                         --------------------------"\
" ---------------------------";

 "Dates             s lgth  mean   std    min    max  "\
 "  mean   std    min    max";
 "---------------------------------------------------"\
 " ---------------------------";

 t=1;  cst=mlsa[t,1];
 tt=ftt; fstt=tt;  lstt=0;
 fdate=ddates[tt,1];   ldate=ddates[tt,1];
 do until t == ltt-ftt+1;  t=t+1;  tt=ftt+t-1;  stay=0;
  if mlsa[t,1] == mlsa[t-1,1];  stay=1;  endif;
  if t==(ltt-ftt+1) and stay==1;  stay=-1; endif;
  if stay le 0;  lstt=tt-1-stay;
    vst=vs[fstt:lstt,cst];   fspt=fspa[fstt-ftt+1:lstt-ftt+1,cst];
    ldate=ddates[lstt,1];  nrt=rows(fspt);
    fmx= fdate~ldate~cst~nrt
           ~meanc(vst)~stdc(vst)~minc(vst)~maxc(vst)
           ~meanc(fspt)~stdc(fspt)~minc(fspt)~maxc(fspt);
    call printfm(fmx,mask,fmt);   print;
    fdate=ddates[tt,1];   fstt=tt;   cst=mlsa[t,1];
  endif;
  cst=mlsa[t,1];
 endo;
 print;

"Summary ";
 j=0; do until j==ns; j=j+1;
    vst=selif(vs[ftt:ltt,j],mlsa.==j);
    fspt=selif(fspa[.,j],mlsa.==j);
    fmx= 0~0~j~rows(vst)
             ~meanc(vst)~stdc(vst)~minc(vst)~maxc(vst)
             ~meanc(fspt)~stdc(fspt)~minc(fspt)~maxc(fspt);
    call printfm(fmx,mask,fmt);   print;
 endo;

 print; print;

 outwidth 80;

 if arn == 0;  retp(Fsa,mlsa,fspa); endif;
 if arn ge 1;  retp(Farsa,mlsa,fspa);  endif;

endp;
