/*  MSMVF.ARC  MSM Objective Function procs             */
/*  Michael Boldin (revised 5/96)                       */
/*  all right reserved, this code may not be sold       */


proc ar1mp(xrho);  local ar1mx;   ar1mx=zeros(ns,ns);
  if __rhosj ne 0;   xrho=xrho[__rhosj];  endif;
  if __ar1m==0;  xrho=reshape(xrho,1,ns);  ar1mx=reshape(xrho,ns,ns);
     elseif __ar1m==1;  ar1mx=reshape(xrho,ns,ns);
     elseif __ar1m==2;  ar1mx=zeros(ns,ns);
            xrho=reshape(xrho,1,ns);  ar1mx=diagrv(ar1mx,xrho);
  endif;
  retp(ar1mx);
endp;

proc rhop(xrho);  local rhom;
  if (__rhosj==0 and __rhosx==0);  rhom=reshape(xrho,arn,ns);
     elseif __rhosx==1.1;  rhom=reshape(xrho,ns,arn)';
     else;  rhom=reshape(xrho,arn,rhoxns);  rhom=rhom[.,__rhosj];
  endif;
 retp(rhom);
endp;

proc rhoshape(xrho); retp(xrho); endp;


proc (0)=mbhf(xph);  xbh=xph;
  Bs=xbh[1:ns*k]; Bs=reshape(Bs,k,ns);  sees=abs(xbh[ns*k+1:ns*k+ns])';
  xq=xbh[ns*k+ns+1:rows(xbh)]; q=reshape(xq,ns,ns-1);
  Q=rq(q~(1-sumc(q'))); lqo=lqov(Q); po=lqo;
endp;

proc (0)=mbharf(xph);  xbh=xph;
  Bs=xbh[1:ns*k]; Bs=reshape(Bs,k,ns);  sees=abs(xbh[ns*k+1:ns*k+ns])';
  xrhos=xbh[ns*k+ns+1:ns*k+ns+nxrhos];
  if arn==1;  ar1m=ar1mp(xrhos);
     else;  rhos=reshape(xrhos,arn,ns);  endif;
  xq=xbh[ns*k+ns+nxrhos+1:rows(xbh)];   q=reshape(xq,ns,ns-1);
  Q=rq(q~(1-sumc(q'))); lqo=lqov(Q); po=lqo;
endp;

proc (0)=mbhn(xph);
print "** MBHN proc not defined, __mbhn = " __mbhn "option";
endp;
proc (0)=mbharn(xph);
print "** MBHARN proc not defined, __mbhn = " __mbhn "option";
endp;


proc (0)=mbhp(xph);  local lrx, fxn, lxn, xns;
  xbh=xph; lrx=rows(xbh);

  Bs=xbh[1:nxbs,.]; Bs=reshape(Bs[__bsk],k,ns);

  fxn=nxbs+1; lxn=fxn+nxsees-1; sees=abs(xbh[fxn:lxn,.])';
  if __nxsees==1; sees=sees*i1;
    elseif nxsees ne ns; sees=sees[__seesj];  endif;

  if arn ge 1; fxn=lxn+1; lxn=fxn+nxrhos-1; xrhos=xbh[fxn:lxn,.];
     if arn==1 and __shprho==0; ar1m=ar1mp(xrhos);
        elseif arn==1 and __shprho==1; ar1m=rhoshape(xrhos);  endif;
     if arn ge 2 and __shprho==0; rhos=rhop(xrhos);
        elseif arn ge 2 and __shprho==0; rhos=rhoshape(xrhos);  endif;
  endif;

  fxn=lxn+1;lxn=fxn+nxq-1; xq=xbh[fxn:lxn,.];
  if arn==0 or __rq le 4;
     if __rq==0; Q=reshape(xq,ns,ns-1); endif;
     if __rq==1; q=reshape(xq,ns,ns-1); Q=rq(q~(1-sumc(q')));
        elseif __rq==2; Q=xqtq( reshape(xq,ns,ns-1) );
        elseif __rq==3; Q=rxq(xq);
        elseif __rq==4; Q=restrq(xq,ns,ns,__xq0,__xqk);
     endif;
     if cols(Q) == ns-1; Q=Q~(1-sumc(Q')); endif;
     if arn ge 2 and oaralg==2;
        eaq=eaqm(Q,arn);  esQ=esqp(vec(eaq[.,1:ns-1]),ns,arn);
     elseif arn ge 2;
        eaq=eaqm(Q,arn+1);  esQ=esqp(vec(eaq[.,1:ns-1]),ns,arn+1);
     endif;
  elseif __rq==4.1;  xns=ns^(arn+1);
     esQ=restrq(xq,xns,xns,__xq0,__xqk);  espo=lqov(esq);
  elseif __rq==4.2;  xns=ns^(arn+1);
     eaQ=restrq(xq,xns,ns,__xq0,__xqk);
     if oaralg ne 2;
        esQ=esqp(vec(eaq[.,1:ns-1]),ns,arn+1);  endif;
  endif;

  if __po ne 1 or (arn le 1 or (__rq ne 4.1 and __rq ne 4.2));
     lqo=lqov(Q);
     if __po==0;  po=lqo;
        elseif __po ge 1;  xpo=xbh[lxn+1:lrx,1]';  endif;
     if __po==1;  xpo=xpo~( 1-sumc(xpo') ); po=rq(xpo);
        elseif __po==2;  po=xqtq(xpo); endif;
     if cols(po) eq ns-1; po=po~( 1-sumc(po') ); endif;
  endif;

  if arn ge 2 and oaralg==2;
     if __po==0;  leaqo=leaqoc(eaq,0);
        else;  leaqo=po;  endif;
  /*  elseif arn ge 2 and (__rq==4.2 or oaralg==2);
     leaqo=po';
     if __po==0; leaqo=leaqov(Q,arn); endif;
  */
  elseif arn ge 2;
     if __po==0;  espo=lqov(esq);
        else; espo=po; endif;
  endif;

endp;



/* AR0 specification */
proc msmofn(xx);  local t;
  if __mbhn==-1;  call mbhf(xx);
     elseif __mbhn==0;  call mbhp(xx);
     elseif __mbhn==1;  call mbhn(xx); endif;
  zs[firstt:lastt,.]=y[firstt:lastt]-X[firstt:lastt,.]*Bs;
  Fs[firstt:lastt,.]=pdfn(zs[firstt:lastt,.]./sees)./sees;
  lpt=vofadj*po*Q;
  t=firstt-1;  do until t==lastt; t=t+1; lpt=(lpt * Q) .* Fs[t,.]; endo;
 retp( clnlv(sumc(lpt')) );
endp;


/*  For AR=1 case */
proc msmoar1(xx);  local t, ft;
  if __mbhn==-1;  call mbharf(xx);
     elseif __mbhn==0;  call mbhp(xx);
     elseif __mbhn==1;  call mbharn(xx); endif;
  seesm=l1*sees;
  zs[firstt-1:lastt,.]=y[firstt-1:lastt]-X[firstt-1:lastt,.]*Bs;
  t=firstt-1; lpt=vofadj*po*Q;
  do until t==lastt;  t=t+1;
     ft=pdfn( (j1*zs[t,.]-(zs[t-1,.]'*j1') .* ar1m) ./ seesm ) ./ seesm;
     lpt=lpt * (Q .* Ft);
  endo;
 retp( clnlv(sumc(lpt')) );
endp;


proc msmoar(xbh);  local j, t, tr, ei, zls, ut, ft, far2n;
  if __mbhn==-1;   call mbharf(xbh);
     elseif __mbhn==0;   call mbhp(xbh);
     elseif __mbhn==1;   call mbharn(xbh); endif;
  tr=lastt-firstt+1;  ei=ealsm[.,arn];
  seesm=l1*sees;  rrhos=rev(rhos);
  zs[firstt-arn:lastt,.]=y[firstt-arn:lastt]-X[firstt-arn:lastt,.]*Bs;
  t=firstt;  zls=rev(zs[t-arj,.]);   zls=zlmp(zls,ealsm);
  ut=l1*zs[t,.]-(zls * rrhos);  ft=pdfn(ut./seesm)./seesm;
  ft=vec(ft)';  lpt=vofadj*espo*esQ.*ft;
  do until t==lastt;   t=t+1;
     zls=(reshape(zls[esl1,2:arn],ens,arn-1)~zs[t-1,ei]');
     ut=l1*zs[t,.]-(zls * rrhos);  ft=pdfn(ut./seesm)./seesm;
     ft=vec(ft)'; lpt=(lpt*esQ).*ft;
  endo;
 retp( clnlv(sumc(lpt')) );
endp;


/*  Sometimes faster for AR > 2 */
proc msmoarn(xbh);   local j, ei, t, ut, eaft, zls;
  if __mbhn==-1;   call mbharf(xbh);
    elseif __mbhn==0;   call mbhp(xbh);
    elseif __mbhn==1;   call mbharn(xbh); endif;
  ei=ealsm[.,arn];  seesm=ei1*sees;  rrhos=rev(rhos);
  zs[firstt-arn:lastt,.]=y[firstt-arn:lastt]-X[firstt-arn:lastt,.]*Bs;
  t=firstt;  zls=rev(zs[t-arj,.]);   zls=zlmp(zls,ealsm);
  ut=ei1*zs[t,.] - (zls*rrhos);  eaft=pdfn(ut./seesm) ./ seesm;
  lpt=leaqo*vofadj;  lpt=(lpt*i1) .* eaq .* eaft;
  do until t==lastt; t=t+1;
     zls=(reshape(zls[esl1,2:arn],ens,arn-1)~zs[t-1,ei]');
     ut=l1*zs[t,.]-(zls*rrhos);  eaft=pdfn(ut./seesm)./seesm;
     lpt=sumc(reshape(lpt',ens,ns)');
     lpt=(lpt*i1) .* eaq .* eaft;
  endo;
  retp( clnlv(sumc(sumc(lpt))) );
endp;

